// JavaScript Document

var cardState;
var remoteUrl;
var prefsUrl;
var editQUrl;
var trace;
var hider;
var username;
var password;
var retrievedCard = null;
var cardIsAnswered = true;
var currentOutsideLink;
var int_test = null;
var currentc;


function getCardState(){
	return cardState;
}

function getRetrievedCard(){
	
	
	if(cardIsAnswered == false && typeof retrievedCard != 'undefined'){
		return retrievedCard;
	}else{
		return null;	
	}
}

function resetRetrievedCard(){
	retrievedCard = null;
}

function html_entity_decode(str) {
  var ta=document.createElement("textarea");
  str = str.replace(/</g,"&lt;");
  str = str.replace(/>/g,"&gt;");
  ta.innerHTML=str;
  return ta.value;
}


function clearCard(){
	var card = '<h2>Waiting For Pop</h2>';
	document.getElementById("card").innerHTML = card;
}

function displayGettingMessage(){
	var card = '<h2><img src="assets/images/loader.gif" alt="loader" width="32" height="32" align="absmiddle" />';
	card += '<strong class="brightBlue">Getting Card...</strong></h2>';
	document.getElementById("card").innerHTML = card;
}


function getCard(notify){
	parentSandboxBridge.trace("getCard notify:"+notify);
	//change card to getting message
	if(!notify){
		//changes card content to Getting Card
		displayGettingMessage();
	}
	 var xmlhttp = new XMLHttpRequest();
	 var url = remoteUrl + "air/get.php";
	 url += "?u="+username;
	 var passMd5 = MD5(password);
	 url += "&p="+passMd5;
	 
	  parentSandboxBridge.trace("getting card: "+url);
	 xmlhttp.open("GET", url,false);
	 xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			
			parentSandboxBridge.trace("responseText: "+xmlhttp.responseText);
			var r = eval("("+ xmlhttp.responseText +")");
			if(r.error == 0){
				retrievedCard = r;
				cardIsAnswered = false;
				if(notify == true){
					parentSandboxBridge.renderNotifyWindow();
				}else{
					makeCard();
				}
			}else{
				handleError(r.error);
			}
		}
	}
	
	try{
		xmlhttp.send(null); 
	}catch(error){
		parentSandboxBridge.trace(error); 
		//displayOfflineMessage();
	}

}

function getPoplingsLink(){
	var url = remoteUrl + "poplings";	
	parentSandboxBridge.linkToPage(url);
}


function goToCurrentOutsideLink(){
	parentSandboxBridge.trace("getting wiki link");
	parentSandboxBridge.linkToPage(currentOutsideLink);
}


function getSupportLink(){
	var url = "http://www.getsatisfaction.com/popling";	
	parentSandboxBridge.linkToPage(url);
}

function contactPopling(){
	var url = "http://www.popling.net/about/contact.php";	
	parentSandboxBridge.linkToPage(url);
}

function handleError(error){
	
	//specific error code handling
	if(error.code == 1){
		navToTab('prefs');
		displayUserPassWarning();
	} else if(error.code == 2){
		
		document.getElementById("poplingName").innerHTML = "Error";
		var card ='<strong>'+ error.message +'</strong>';
		card += '<p>You may need to <a href="#" id="getPoplingLink">subscribe to a Popling</a>.</p>';
		document.getElementById("card").innerHTML = card;
		var g = document.getElementById("getPoplingLink");
		g.addEventListener('click',getPoplingsLink);	
	}else{
		document.getElementById("card").innerHTML = card;
	}
	
}

function goToPopling(){
	var popling_id = retrievedCard.p.popling_id;
	var url = remoteUrl + "poplings/view_popling.php?popling_id="+popling_id;
	parentSandboxBridge.linkToPage(url);
}

function containsSpecialChar(){
	var q = retrievedCard.q;
	var c = removePunctuation(q.correct,1,1);
	if(c != q.correct){
	return true;
	}
}


function makeRetrievedCard(){
	parentSandboxBridge.trace("makeRetrievedCard");
	makeCard();
}

function setCopyright(){
	var doLink = false;
	if(retrievedCard.p.copyright != '0' ){
		var cw = retrievedCard.p.copyright;
		parentSandboxBridge.trace("Creating Copyright cw:"+ cw);
		var ct = copyrights[cw]['title'];
		var c = "Copyrighted as: " + ct + ' | ';
	}else{
		c = '';	
	}
	//link
	if(retrievedCard.p.url != '' ){
		var u = retrievedCard.p.url;
		currentOutsideLink = u;
		var d = parseUri(u);
		var l = "Link: <a href='#' id='card_url'>" + d['host']+"</a><img src='assets/images/exLink.gif'  class='exLink' />";
	
		doLink = true;
	}else {
		var l = '';	
	}
	document.getElementById("copy_disp").innerHTML = c + l;
	
	//add click action
	if(doLink){
		var linkButton = document.getElementById("card_url");
		linkButton.addEventListener("click",goToCurrentOutsideLink);
	}
}

function setPopTools(){
	
	var popling_id = retrievedCard.p.popling_id;
	var q_id = retrievedCard.q.q_id;
	var u = retrievedCard.u;
	var l = retrievedCard.l;
	
	prefsUrl = remoteUrl +  "poplings/set_prefs.php?popling_id="+popling_id;
	if(u.permission == 1){
		editQUrl = remoteUrl + "poplings/make_question.php?popling_id=" + popling_id + "&q_id="+q_id;
	}else{
		document.getElementById("editQB").style.display = "none";
	}
	//easy and hardlist button creation
	if(l == "banked"){
		create_banked_ListB(true);
		create_hardlist_ListB(false);
	}else if(l == "hardlist"){
		create_banked_ListB(false);
		create_hardlist_ListB(true);
	}else{
		create_banked_ListB(false);
		create_hardlist_ListB(false);
	}
}
function makeCard(){
	
	var q = retrievedCard.q;
	var p = retrievedCard.p;
	
	
	var cardType = retrievedCard.r; 
	
	parentSandboxBridge.trace("make card - cardType: "+cardType);
	//popling
	document.getElementById("poplingName").innerHTML = "<a href='#' id='poplingLink'>"+p.name+"</a>";
	document.getElementById("poplingLink").addEventListener('click',goToPopling);
	
	var card = "<h2>"+q.question+"</h2>";
	
	if(cardType == 0 || cardType == null){
		//display or flash cards
		cardState = "question-display";
		if(p.q_type == 3){
			parentSandboxBridge.trace("make card - p.q_type: "+p.q_type);
			//display card only, no answer card
			card += '<input class="button_a" type="button" value="Next Card" id="nextCard_b" />';
			document.getElementById("card").innerHTML = card;
			var nextButton = document.getElementById('nextCard_b');
			nextButton.addEventListener("click",skipCard);
			document.getElementById("nextCard_b").focus();
		}else{
			//regular flash card
			card += '<input class="button_a" type="button" value="Reveal Answer" id="reveal_b" />';
			document.getElementById("card").innerHTML = card;
			var ansButton = document.getElementById('reveal_b');
			ansButton.addEventListener("click",revealAnswer);
			document.getElementById("reveal_b").focus();
			
		}
	}else if(cardType == 1){
		//RETENTION CARD!
		parentSandboxBridge.trace("cardType is reten");
		cardState = "question-reten";
	   //var  retenHTML =  '<form id="reten_form">';
	   var retenHTML = '<h2>'+card+'</h2>';
		retenHTML += '<input type="text" id="answer_txt"/>';
		retenHTML += '<input type="submit" value="go" id="go_sub"/>';
		//retenHTML += '</form>';
		
		//test to display message
		var specChar = containsSpecialChar();
		if(specChar){
			retenHTML += '<p><small>(&#225;, &#241;, !, etc. not required)</small></p>';
		}
		
		document.getElementById("card").innerHTML = retenHTML;
		
		
		var go_b = document.getElementById("go_sub");
		go_b.addEventListener('click',submitAnswer);
		/*
		var retenForm = document.getElementById("reten_form");
		//retenForm.addEventListener('onSubmit',submitAnswer);
		retenForm.action = submitAnswer;
		retenForm.onSubmit = submitAnswer;
		*/
		document.getElementById("answer_txt").focus();
	}
	
	setPopTools();
	//setCopyright();
	
	//renderProFeatures(recent);
}


function swapCorrect(){
	var id =this.id;
	var recentQs = retrievedCard.recent;
	
	var q = this.innerHTML;
	
	this.innerHTML = this.title;//recentQs[id];
	this.title = q;
	
	//document.getElementById("recent_"+currentc).innerHTML = currentc;
	//currentc = '';
	
}


function renderProFeatures(){
	var recentQs = retrievedCard.recent;
	var li = '';
	var recentList = document.getElementById("recent");
	
	
	//destroy all children
	if ( recentList.hasChildNodes() ){
   		 while ( recentList.childNodes.length >= 1 ){
        	recentList.removeChild( recentList.firstChild );       
   		 } 
	}

	
	for (var q in recentQs) {   
	   var c = recentQs[q];
	   var li = document.createElement("LI");
	   recentList.appendChild(li);
	   li.innerText=q;
	   li.id = q;
	   li.title = c;
	   li.addEventListener('mouseover',swapCorrect); 
		
	}; 
	
}

function deleteFromBanked() { 
	manageList("banked","delete"); 
}

	function addToBanked() { 
	manageList("banked","add"); 
}

function create_banked_ListB(onList){
	if(onList == true){
		document.getElementById("deleteEasy").style.display="inline";
		document.getElementById("addEasy").style.display="none";
	}else{
		
		document.getElementById("deleteEasy").style.display="none";
		document.getElementById("addEasy").style.display="inline";
	} 
	
}

function create_hardlist_ListB(onList){
	if(onList == true){
		document.getElementById("deleteHard").style.display="inline";
		document.getElementById("addHard").style.display="none";
	}else{
		
		document.getElementById("deleteHard").style.display="none";
		document.getElementById("addHard").style.display="inline";
	} 
}

function hidePopling(){
	parentSandboxBridge.hider();
}

function revealAnswer(){
	//used by 1st state of flash card only.
	
	var q = retrievedCard.q;
	
	cardState = "question-show-answer";
	var card = "";
	card += "<h2><span class='question'>"+ q.question +"</span> = <span class='correct'>"+ q.correct +"</span></h2>";
	card += "<p>"+ q.notes +"</p>";
	
	card += '<input class="button_a" type="button" value="Next Card" id="getCardB">';
	card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';
	
	document.getElementById("card").innerHTML = card;
			
	var h = document.getElementById('hiderButton');
	
	document.getElementById('getCardB').focus();
	h.addEventListener("click", hidePopling);
	
	var g = document.getElementById('getCardB');
	g.addEventListener("click",getCard);
	submitScore(2,0);
}

function submitAnswer(){
	
	var q = retrievedCard.q;
	
	var userAnswer = document.getElementById("answer_txt").value;
	
	parentSandboxBridge.trace("submitAnswer: "+userAnswer);
	
	var c = removePunctuation(q.correct,1);
	var a = removePunctuation(userAnswer,0);
	
	parentSandboxBridge.trace("submitting answer");
	
	var card = "";
	
	if(a == c){
		var answer = 1;
		card += "<h1><img src='assets/images/correct.gif'  align='absmiddle' />&nbsp;Correct</h1>";
		card += "<h2>"+ q.question +" = "+ q.correct +"</h2>";
	}else{
		var answer = 0;
		var userAnswerDisp;
		if(userAnswer == ''){
			userAnswerDisp = '______';
		}else{
			userAnswerDisp = userAnswer;
		}
		card += "<h1 class='incorrect'><img src='assets/images/incorrect.gif' align='absmiddle' /><strong><em>" + userAnswerDisp + "</em></strong> is Incorrect</h1>";
		card += "<h2>"+ q.question +" = "+ q.correct +"</h2>";	
	}
	
	if(q.notes != ""){
			card += "<h4 class='notes'>"+  q.notes +"</h4>";
		}
	if(answer == 1){
		//parentSandboxBridge.trace("creating correct buttons");
		card += '<input class="button_a" type="button" value="Next Card" id="getCardB">';
		card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';
		
		document.getElementById("card").innerHTML = card;
			
		var h = document.getElementById('hiderButton');
		h.addEventListener("click", hidePopling);
		
		var g = document.getElementById('getCardB');
		g.addEventListener("click",getCard);
		
		
		document.getElementById("getCardB").focus();
	}else{
		
		card += '<input class="button_a" type="button" value="Try Again" id="tryAgainB">';
		card += '<input class="button_a" type="button" value="Skip" id="skipB">';
		card += '<input class="button_a" type="button" id="hiderButton" value="Hide">';
		
		document.getElementById("card").innerHTML = card;
			
		
		var h = document.getElementById('hiderButton');
		h.addEventListener("click", hidePopling);
		
		var s = document.getElementById('skipB');
		s.addEventListener("click",skipCard);
		
		var g = document.getElementById('tryAgainB');
		g.addEventListener("click",makeCard);
		
		document.getElementById("tryAgainB").focus();
	}

	//for keypress event:
	cardState = "answered";
	submitScore(answer,0);
}


function submitScore(answer,skipReten){
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	//reset title and question for notify window
	cardIsAnswered = true;
	//resetRetrievedCard();
	
	//update status
	parentSandboxBridge.trace("score being submitted" + answer + " skipReten:" +skipReten);
	
	var url = remoteUrl + "air/score.php";
	url += "?popling_id="+p.popling_id;
	url += "&q_id="+q.q_id;
	url += "&u="+username;
	url += "&p="+MD5(password);
	url += "&answer="+String(answer);
	
	if(skipReten == 1){
		url += "&skipReten=1";
	}
	
	
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open("GET",url,true);
	xmlhttp.onreadystatechange = function() {
		 if (xmlhttp.readyState == 4) {
			//parentSandboxBridge.trace("submit response: "+xmlhttp.responseText);
			var r = eval("("+ xmlhttp.responseText +")");
			if(r.result == "1"){
				//update status
				var status = "score submitted";
			}else{
				//update status
				var status = "error sumitting score";
			}
			parentSandboxBridge.trace(status);
		 }
	}
	xmlhttp.send(null); 
	
}

function skipCard(){
	parentSandboxBridge.trace("skipping card");
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	cardIsAnswered = true;
	//resetRetrievedCard();
	
	var url = remoteUrl + "air/score.php";
	url += "?popling_id="+p.popling_id;
	url += "&q_id="+q.q_id;
	url += "&skipReten=1";
	url += "&u="+username;
	url += "&p="+MD5(password);
	
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open("GET", url,false);
	xmlhttp.onreadystatechange = function() {
		 if (xmlhttp.readyState == 4) {
			var r = eval("("+ xmlhttp.responseText +")");
			if(r.result == "1"){
				//update status
				var status = "card skipped";
			}else{
				//update status
				var status = "error skipping card";
			}
			parentSandboxBridge.trace(status);
			getCard();
		 }
	}
	
	try{
		xmlhttp.send(null); 
	}catch(error){
		parentSandboxBridge.trace(error); 
		//displayOfflineMessage();
	}
 
}

function parseUri (str) {
	var	o   = {
	strictMode: false,
	key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
	q:   {
		name:   "queryKey",
		parser: /(?:^|&)([^&=]*)=?([^&]*)/g
	},
	parser: {
		strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
		loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
	}
};
	var m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str);
	var uri = {};
	var i   = 14;

	while (i--) uri[o.key[i]] = m[i] || "";

	uri[o.q.name] = {};
	uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
	});

	return uri;
};


