// JavaScript Document

var prefsFile; // The preferences file
var prefsXML; // The XML data
var stream; // The FileStream object used to read and write prefsFile data.
var poplingPrefs; //global var for enire app
var firstRun = false;

/**
* Called when the application is first rendered, and when the user clicks the Save button.
* If the preferences file *does* exist (the application has been run previously), the method 
* sets up a FileStream object and reads the XML data, and once the data is read it is processed. 
* If the file does not exist, the method calls the setPrefs() method which creates the file. 
*/

function getPrefs(){
	trace("getPrefs");
	prefsFile = air.File.applicationStorageDirectory;
	prefsFile = prefsFile.resolvePath("preferences.xml"); 
	stream = new air.FileStream();
	if (prefsFile.exists) {
		trace("prefs exist, getting");
		stream.open(prefsFile, air.FileMode.READ);
		prefsXML = stream.readUTFBytes(stream.bytesAvailable);
		stream.close();
		var poplingPrefs = parsePrefsXML(prefsXML);
		return poplingPrefs;
	}else{
		trace("prefs don't exist, this is first run");
		return false;
	}
}


/**
* Called after the data from the prefs file has been read. The readUTFBytes() reads
* the data as UTF-8 text, and the XML() function converts the text to XML. The x, y,
* width, and height properties of the main window are then updated based on the XML data.
*/
function parsePrefsXML(prefsXML){
	trace("parsing prefs" + prefsXML);
	var pt = new Array();
	var domParser = new DOMParser();
	prefsXML = domParser.parseFromString(prefsXML, "text/xml");
	var userPrefs = prefsXML.getElementsByTagName("userPrefs")[0];
	var appPrefs = prefsXML.getElementsByTagName("appPrefs")[0];
	
	pt['name'] = userPrefs.getAttribute("name");
	pt['popTime'] = appPrefs.getAttribute("popTime");
	pt['teaser'] = appPrefs.getAttribute("teaser");
	pt['notifyPos'] = appPrefs.getAttribute("notifyPos");
	
	pt['versionNotes'] = appPrefs.getAttribute("versionNotes");
	
	return pt;
}

/**
 *  Constructs XML data and saves the 
 * data to the preferences.xml file.  Creates the XML object 
*/
function setPrefs(un,pass,pt,t,np,s,vn){
	
	setPass(pass);
	setRunAtStartup(s);
	
	var cr = "";
	prefsXML =  
	  "<?xml version='1.0' encoding='utf-8'?>" + cr
	+ "<preferences>" + cr 
	+ "    <userPrefs name='" + un + "'" + " />" + cr
	+ "    <appPrefs popTime='" + pt + "' teaser='" + t + "' notifyPos='" + np + "' />" + cr
	+ "    <update last='' versionNotes='"+vn+"'" + " />" + cr		
	+ "</preferences>";
	
	stream = new air.FileStream();
	stream.open(prefsFile, air.FileMode.WRITE);
	stream.writeUTFBytes(prefsXML);
	stream.close();
	trace("after prefs file written");
	
	
	trace("prefs set, redirecting to root");
	cleanUp();
	window.location = "root.html";
}

////
///  Password info is stored separately and encryped
//
	
function setPass(str){
	trace("setPass:" +str);
	data = new air.ByteArray();
	data.writeUTFBytes( str );
	air.EncryptedLocalStore.setItem( 'password', data );	
}


function getPass(m){
	var sv = air.EncryptedLocalStore.getItem( 'password' );
	if(sv!=null){
		sv = sv.readUTFBytes( sv.bytesAvailable );	
		return sv;
	}else{
		return '';	
	}
}

function getUser(){
	var u = poplingPrefs['name'];
	return u;
}

function setRunAtStartup(toggle){
	trace("setRunAtStartup: "+toggle);
	try {
        air.NativeApplication.nativeApplication.startAtLogin = toggle;
    } catch (error){
		$("app_mess").innerHTML = error;
       // alert("set: "+error);
    }
}

function getRunAtStartup(){
	try {
       return air.NativeApplication.nativeApplication.startAtLogin
    } catch (error) {
		$("app_mess").innerHTML = error;
        return false;
    }
	//return true;
}