// JavaScript Document
var prefs_sb;
var currentTab;
var thisVersion;

function navToTab(t){
	
	parentSandboxBridge.trace("navToTab: "+t );
	document.getElementById('cards').style.display = 'none';
	document.getElementById('prefs').style.display = 'none';
	document.getElementById('flag_card').style.display = 'none';
	document.getElementById('main_messages').style.display = 'none';
	
	document.getElementById(t).style.display = 'inline';
	
	if(t == "prefs"){
		if(typeof prefs_sb == "object"){
			renderPreferences();
		}
	}else if(t == 'cards'){
		getCard();
	}
	
	currentTab = t;
	
}

function getCurrentTab(){
	return currentTab;
}

//KEY ACTIONS
//Handles keyboard shortcuts for hiding, return key for next card, 
//return key for submit answer, etc.
function keyPressEvent(e){
	if(e.keyCode == 119 && e.metaKey || e.keyCode == 119 && e.altKey){ //hide on cntrl w press
		hider();
	}else if (e.keyCode == 13 && cardState == "question-reten"){ //hide on cntrl w press
		submitAnswer();
	}
}

document.onkeypress=keyPressEvent;

function continueFromFeatures(){
	parentSandboxBridge.trace("updating versionViewed: "+thisVersion);
	parentSandboxBridge.updateVersionViewed(thisVersion);
	navToTab('cards');	
}


function initPopUI(){
	prefs_sb = parentSandboxBridge.getPrefs();
	username = parentSandboxBridge.getUser();
	password = parentSandboxBridge.getPass(true);
	remoteUrl = parentSandboxBridge.getRemoteURL();
	
	//has the user viewed the version notes?
	var vv = parentSandboxBridge.getVersionViewed();
	thisVersion = parentSandboxBridge.getThisVersion();
	
	
	parentSandboxBridge.trace("versionViewed: "+vv+" thisVersion: "+thisVersion);
	
	if(typeof prefs_sb != "object"){ //prefs don't exist, display message
		navToTab('prefs');
		displayNewUserMessage();
	}else if(vv != thisVersion){
		displayNewFeatures();
	}else{
		navToTab('cards');
	}
}


function toggleOnOff(){
	var of = document.getElementById('onOff').innerHTML;
	parentSandboxBridge.trace('of'+of);
	if(of == 'Stop Popping'){
		parentSandboxBridge.trace('Stopping');
		document.getElementById('onOff').innerHTML = 'Start Popping';
		parentSandboxBridge.turnOff();
	}else{
		document.getElementById('onOff').innerHTML = 'Stop Popping';
		parentSandboxBridge.turnOn();
	}
}

function resetPassLink(){
	var url = "http://popling.net/signup/get_password.php";
	parentSandboxBridge.linkToPage(url);
}


function getUpdate(){
	parentSandboxBridge.getAirFile();
}

//////////////////////////////////////
//Poptool buttons
//////////////////////////////////////

function manageList(list,action){
	parentSandboxBridge.trace("managing "+list+" action is " +action);
	
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	
	
	var url = remoteUrl + "air/lists.php";
	url += "?popling_id="+p.popling_id;
	url += "&q_id="+q.q_id;
	url += "&list="+list;
	url += "&u="+username;
	url += "&p="+MD5(password);
	url += "&"+action+"=1";
	//parentSandboxBridge.trace(url);
	
	xmlhttp = new XMLHttpRequest();
	xmlhttp.open("GET", url,true);
	xmlhttp.onreadystatechange = function() {
		 if (xmlhttp.readyState == 4) {
			parentSandboxBridge.trace(xmlhttp.responseText);
			if(action == "add"){
				l = list;
			}else{
				l = "fulllist";
			}
			if(list == "banked"){
				if(action == "add"){
					create_banked_ListB(true);
				}else{
					create_banked_ListB(false);
				}
			}else{
				//hard list
				if(action == "add"){
					create_hardlist_ListB(true);
				}else{
					create_hardlist_ListB(false);
				}
			}
		 }
	}
	xmlhttp.send(null); 
}


function unsubscribe(){
	
	//var c = confirm("Are you sure you would like to unsubscribe from this Popling?"); 	
	//if(c){
		parentSandboxBridge.trace("unsubscribed");
		
		var p = retrievedCard.p;
		var q = retrievedCard.q;
		
		var url = remoteUrl + "air/unsub.php";
		url += "?popling_id="+p.popling_id;
		url += "&u="+username;
		url += "&p="+MD5(password);
		xmlhttp = new XMLHttpRequest();
		xmlhttp.open("GET", url,true);
		xmlhttp.onreadystatechange = function() {
			 if (xmlhttp.readyState == 4) {
				parentSandboxBridge.trace(xmlhttp.responseText);
				getCard();
			 }
		}
		xmlhttp.send(null); 
	//}
}



///////////////////////////////////////
// FLAG UI
//////////////////////////////////////


function getCheckedValue(radioObj) {
	if(!radioObj)
		return "";
	var radioLength = radioObj.length;
	if(radioLength == undefined)
		if(radioObj.checked)
			return radioObj.value;
		else
			return "";
	for(var i = 0; i < radioLength; i++) {
		if(radioObj[i].checked) {
			return radioObj[i].value;
		}
	}
	return "";
}

function sendFlag(){
	var o = document.forms['flag_radio_form'].elements['flag_card'];
	var v = getCheckedValue(o);
	var p = retrievedCard.p;
	var q = retrievedCard.q;
	var url = remoteUrl + "air/flag.php";
	url += "?popling_id="+p.popling_id;
	url += "&q_id="+q.q_id;
	url += "&flag="+v;
	url += "&u="+username;
	url += "&p="+MD5(password);
	parentSandboxBridge.trace(url);
	xmlhttp = new XMLHttpRequest();
	xmlhttp.open("GET", url,true);
	xmlhttp.onreadystatechange = function() {
		 if (xmlhttp.readyState == 4) {
			parentSandboxBridge.trace(xmlhttp.responseText);
			showFlagResponse();
		 }
	}
	xmlhttp.send(null); 
	
	
}

function showFlagResponse(){
	document.getElementById("flaggit").style.display = "none";
	document.getElementById("flag_response").style.display = "inline";
}


function flagContinue(){
	document.getElementById('flaggit').style.display = 'inline';
	document.getElementById('flag_response').style.display = 'none';
	navToTab("cards");
}
//end flag

///////////////////////////////////////
// PREFERENCES UI
//////////////////////////////////////

function renderPreferences(){
	parentSandboxBridge.trace("rendering prefs");
	parentSandboxBridge.trace(" new user "+typeof prefs_sb);
	
	if(typeof prefs_sb != "object"){	
		displayNewUserMessage();
	}
	
	var d = document.getElementById;
	document.getElementById('p_username').value = prefs_sb['name'];
	document.getElementById('p_password').value = parentSandboxBridge.getPass();
	
	document.getElementById('p_popTime').value = prefs_sb['popTime'];
	if(prefs_sb['teaser'] == "true"){
		var t = "checked";
	}else{
		var t = "";
	}
	document.getElementById('p_teaser').checked = t; 
	
	np = prefs_sb['notifyPos'];
	
	document.getElementById('p_notify_pos').selectedIndex = np; 
	parentSandboxBridge.trace("  NOTIFY: "+np);
	
	
	//run at startup
	var runAtStart = parentSandboxBridge.getRunAtStartup();
	parentSandboxBridge.trace("runAtStart: "+runAtStart);
	
	if(runAtStart == "undefined"){
		runAtStart = true;
	}
	
	document.getElementById('p_startup').checked = runAtStart;
	
}

function savePrefs(){
	parentSandboxBridge.trace("savePrefs from index.html");
	
	//set prefs in XML
	var d = document.getElementById;
	var un = document.getElementById('p_username').value;
	var pass = document.getElementById('p_password').value;
	var pt = document.getElementById('p_popTime').value;
	var t =	document.getElementById('p_teaser').checked;
	var np = document.getElementById('p_notify_pos').selectedIndex;
	
	//run at startup
	var s =	document.getElementById('p_startup').checked;
	
	if(pass != '' && un != ''){
		//all set, setting prefs
		parentSandboxBridge.setPrefs(un,pass,pt,t,np,s);
	}else{
		parentSandboxBridge.trace("user or pass not set");
		userNamePassError();
	}	
	
}

function cancelPrefs(){
	//if username and password are not set, don't go to cards
	var d = document.getElementById;
	var pass = document.getElementById('p_password').value;
	var un = document.getElementById('p_username').value;
	if(pass != '' && un != ''){
		navToTab('cards');
	}else{
		userNamePassError();
	}
}

function poplingLink(){
	var url = "http://www.popling.net";
	parentSandboxBridge.linkToPage(url);
}

///////////////////////////////////////
// END PREFERENCES UI
//////////////////////////////////////

function bridgeChild(){
	childSandboxBridge = {
		'initPopUI'						:	initPopUI,
		'navToTab'						:	navToTab,
		'clearCard'						:	clearCard,
		'getCard'						:	getCard,
		'getCardState'					:	getCardState,
		'makeRetrievedCard'				:	makeRetrievedCard,
		'displayOfflineMessage'			: 	displayOfflineMessage,
		'displayUpgradeMessage'			:	displayUpgradeMessage,
		'displayVersionCheckMessage'	:	displayVersionCheckMessage,
		'getRetrievedCard'				:	getRetrievedCard,
		'getCurrentTab'					:	getCurrentTab
	};
}

function initUI(){
	bridgeChild();
}